/**
******************************************************************************
* @file         w5500_conf.c
* @version      V1.0
* @date         2020-06-05
* @brief        MCUֲw5500Ҫ޸ĵļw5500MACIPַ
*        
* @company      Ƽ޹˾
* @information  WIZnet W5500ٷ̣ȫ̼֧֣۸ƴ
* @website      www.wisioe.com
* @forum        www.w5500.cn
* @qqGroup      579842114
* @Support      QQ:2571856470Mob:18998931307
* @Email        support@wisioe.com
******************************************************************************
*/
#include <stdio.h> 
#include <string.h>
#include "w5500_conf.h"
#include "utility.h"
#include "w5500.h"
#include "socket.h"
#include "bsp_spi.h"
#include "bsp_TiMbase.h"
#include "bsp_flash.h"
#include "dhcp.h"
#include "http_server.h"

CONFIG_MSG  ConfigMsg, RecvMsg;                             // ýṹ

uint16 rxlen=0;
uint8 rxbuf[1024];

/*MACַֽڱΪż
  w5500ͬһֳʹòͬMACַ
*/
uint8 mac[6]={0x00,0x08,0xdc,0x11,0x11,0x11};

/*ĬIPϢ*/
uint8 local_ip[4] = {192,168,1,232};                        // w5500ĬIPַ
uint8 subnet[4] = {255,255,255,0};                          // w5500Ĭ
uint8 gateway[4] = {192,168,1,1};                           // w5500Ĭ
uint8 dns_server[4] = {114,114,114,114};                    // w5500ĬDNS

uint16 local_port = 8080;                                   // 屾ض˿

/*ԶIPϢ*/
uint8  remote_ip[4] = {192,168,1,100};                      // ԶIPַ
uint16 remote_port = 8080;                                  // Զ˶˿ں

/*IP÷ѡѡ*/
uint8  ip_from=IP_FROM_DEFINE;      

uint32 ms=0;                                                // 
vu8    ntptimer = 0;                                        // NPT

/**
*@brief  ʼW5500ĸλжϹܽ
*@param  
*@return 
*/
void reset_break_gpio_init(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC,ENABLE);
  /* PB_01 -> RST */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOB, &GPIO_InitStructure);
  /* PC_05 -> INT */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
  GPIO_Init(GPIOC, &GPIO_InitStructure);
}

/**
*@brief  W5500IPַ
*@param  
*@return 
*/
void set_w5500_netinfo(void)
{
#ifdef  _HTTP_SERVER_H_
	uint8 temp;
#endif
  // ƶϢýṹ
  memcpy(ConfigMsg.mac, mac, 6);
  memcpy(ConfigMsg.lip,local_ip,4);
  memcpy(ConfigMsg.sub,subnet,4);
  memcpy(ConfigMsg.gw,gateway,4);
  memcpy(ConfigMsg.dns,dns_server,4);
#ifdef  _HTTP_SERVER_H_
/*ʹHTTP ServerʱЧʹ"http_server.h"ͷļ*/
  ReadFlashNBtye(0,&temp,1);
  if(temp != 255)
    ip_from = IP_FROM_FLASH;
  else
    ip_from = IP_FROM_DEFINE;
#endif
  switch(ip_from)
  {
    case IP_FROM_DEFINE:
      printf(" ʹöIPϢW5500\r\n");
      break;
#ifdef  _HTTP_SERVER_H_
    case IP_FROM_FLASH:
      printf(" ʹFlashIPϢW5500\r\n");
      ReadFlashNBtye(0,ConfigMsg.lip,12);
      break;
#endif
  }
  setSUBR(ConfigMsg.sub);
  setGAR(ConfigMsg.gw);
  setSIPR(ConfigMsg.lip);

  getSIPR (local_ip);
  printf(" W5500 IPַ   : %d.%d.%d.%d\r\n", local_ip[0],local_ip[1],local_ip[2],local_ip[3]);
  getSUBR(subnet);
  printf(" W5500  : %d.%d.%d.%d\r\n", subnet[0],subnet[1],subnet[2],subnet[3]);
  getGAR(gateway);
  printf(" W5500      : %d.%d.%d.%d\r\n", gateway[0],gateway[1],gateway[2],gateway[3]);
}

/**
*@brief  W5500MACַ
*@param  
*@return 
*/
void set_w5500_mac(void)
{
  // ϢҪѡ
  ConfigMsg.sw_ver[0]=FW_VER_HIGH;
  ConfigMsg.sw_ver[1]=FW_VER_LOW;
  
  memcpy(ConfigMsg.mac, mac, 6);
  setSHAR(ConfigMsg.mac);
  getSHAR(mac);
  printf(" W5500 MACַ  : %02x.%02x.%02x.%02x.%02x.%02x\r\n", mac[0],mac[1],mac[2],mac[3],mac[4],mac[5]);
}


/**
*@brief  W5500λú
*@param  
*@return 
*/
void reset_w5500(void)
{
  GPIO_ResetBits(GPIOB, GPIO_Pin_1);
  delay_ms(500);
  GPIO_SetBits(GPIOB, GPIO_Pin_1);
  delay_ms(1500);
}

/**
*@brief		W5500Ƭѡ˿SCSnΪ
*@param		
*@return	
*/
void iinchip_csoff(void)
{
	cs_low();
}

/**
*@brief		W5500Ƭѡ˿SCSnΪ
*@param		
*@return	
*/
void iinchip_cson(void)
{	
   cs_high();
}

/**
*@brief		STM32 SPI1д8λ
*@param		datд8λ
*@return	
*/
uint8 IINCHIP_SpiSendData(uint8 dat)
{
	return(spi_read_send_byte(dat));
}

/**
*@brief		дһ8λݵW5500
*@param		addrbsb: дݵĵַ
*@param   dataд8λ
*@return	
*/
void IINCHIP_WRITE(uint32 addrbsb,uint8 data)
{
	iinchip_csoff();
	IINCHIP_SpiSendData( (addrbsb & 0x00FF0000)>>16);
	IINCHIP_SpiSendData( (addrbsb & 0x0000FF00)>> 8);
	IINCHIP_SpiSendData( (addrbsb & 0x000000F8) + 4);
	IINCHIP_SpiSendData(data);
	iinchip_cson();
}

/**
*@brief		W5500һ8λ
*@param		addrbsb: дݵĵַ
*@param   dataдĵַȡ8λ
*@return	
*/
uint8 IINCHIP_READ(uint32 addrbsb)
{
	uint8 data = 0;
	iinchip_csoff();
	IINCHIP_SpiSendData( (addrbsb & 0x00FF0000)>>16);
	IINCHIP_SpiSendData( (addrbsb & 0x0000FF00)>> 8);
	IINCHIP_SpiSendData( (addrbsb & 0x000000F8))    ;
	data = IINCHIP_SpiSendData(0x00);
	iinchip_cson();
	return data;
}

/**
*@brief		W5500дlenֽ
*@param		addrbsb: дݵĵַ
*@param   bufдַ
*@param   lenַ
*@return	lenַ
*/
uint16 wiz_write_buf(uint32 addrbsb,uint8* buf,uint16 len)
{
	uint16 idx = 0;
	if(len == 0) printf(" Unexpected2 length 0\r\n");
	iinchip_csoff();
	IINCHIP_SpiSendData( (addrbsb & 0x00FF0000)>>16);
	IINCHIP_SpiSendData( (addrbsb & 0x0000FF00)>> 8);
	IINCHIP_SpiSendData( (addrbsb & 0x000000F8) + 4); 
	for(idx = 0; idx < len; idx++)
	{
		IINCHIP_SpiSendData(buf[idx]);
	}
	iinchip_cson();
	return len;
}

/**
*@brief		W5500lenֽ
*@param		addrbsb: ȡݵĵַ
*@param 	bufŶȡ
*@param		lenַ
*@return	lenַ
*/
uint16 wiz_read_buf(uint32 addrbsb, uint8* buf,uint16 len)
{
  uint16 idx = 0;
  if(len == 0)
  {
    printf(" Unexpected2 length 0\r\n");
  }
  iinchip_csoff();
  IINCHIP_SpiSendData( (addrbsb & 0x00FF0000)>>16);
  IINCHIP_SpiSendData( (addrbsb & 0x0000FF00)>> 8);
  IINCHIP_SpiSendData( (addrbsb & 0x000000F8));
  for(idx = 0; idx < len; idx++)
  {
    buf[idx] = IINCHIP_SpiSendData(0x00);
  }
  iinchip_cson();
  return len;
}

/**
*@brief  STM32ϵͳλ
*@param  
*@return 
*/
void reboot(void)
{
  pFunction Jump_To_Application;
  uint32 JumpAddress;
  printf(" ϵͳС\r\n");
  JumpAddress = *(vu32*) (0x00000004);
  Jump_To_Application = (pFunction) JumpAddress;
  Jump_To_Application();
}

/**
*@brief  dhcpõĶʱʼ
*@param  
*@return 
*/
void dhcp_timer_init(void)
{
  timer2_init();
}

/**
*@brief  ntpõĶʱʼ
*@param  
*@return 
*/
void ntp_timer_init(void)
{
  timer2_init();
}

/**
*@brief  STM32ʱ2ʼ
*@param  
*@return 
*/
void timer2_init(void)
{
  TIM2_Configuration();                                        //  TIM2 ʱ
  TIM2_NVIC_Configuration();                                   //  ʱжȼ
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2 , ENABLE);        //  TIM2 ¿ʱӣʼʱ 
}

/**
*@brief  ʱ2жϺ
*@param  
*@return 
*/
void timer2_isr(void)
{
  ms++;  
  if(ms>=1000)
  {  
    ms=0;
    dhcp_time++;             // DHCPʱ1S
#ifndef __NTP_H__
    ntptimer++;              // NTPʱ1S
#endif
  }
}

/**
*@brief  
*@param  
*@return 
*/
void PHY_check(void)
{
  uint8 PHY_connect=0;
  PHY_connect=0x01&getPHYStatus();
  if(PHY_connect==0)
  {
    printf(" \r\n Ƿ?\r\n");
    PHY_connect = 0;
    do
    {
      close(PHY_connect++);
    }while(PHY_connect < 4);
    PHY_connect = 0;
    while(PHY_connect == 0) 
		{
      PHY_connect=0x01&getPHYStatus();
      printf(" .");
      delay_ms(500);
    }
    printf(" \r\n");
  }
}

/**
*@brief  ȡPHYĴ
*@param  
*@return PHYSRĴֵ
*/
uint8 getPHYStatus( void )
{
  return IINCHIP_READ(PHYCFGR);
}

/**
*@brief  KPALVIRĴ
*@param  iõsocket
*@param  valõʱ(5sλ)
*@return 
*/
void setKPALVTR(SOCKET i,uint8 val)
{
  IINCHIP_WRITE(Sn_KPALVTR(i),val);
}
